package com.prosperitylife;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.servlet.http.HttpSession;

import org.apache.log4j.Logger;
import org.apache.log4j.MDC;

import io.swagger.api.V001SNAPSHOTApi;
import io.swagger.model.TestRequest;
import io.swagger.model.TestResponse;

@RequestScoped
public class TestResource implements V001SNAPSHOTApi
{
    protected static final String SESSION_ID_LOGGING_KEY = "session.id";
    
    protected final Logger logger;

    @Inject
    protected HttpSession httpSession;

    public TestResource()
    {
        this.logger = Logger.getLogger(TestResource.class);
    }

    @Override
    public TestResponse v001SNAPSHOTTestPost(TestRequest body)
    {
        MDC.put(TestResource.SESSION_ID_LOGGING_KEY,
                this.httpSession.getId());

        try
        {
            Logger logger = this.getLogger();

            logger.debug("Received the following request: " + body);

            TestResponse testResponse = new TestResponse();

            testResponse.setSuccessful(true);

            logger.debug("Replying with the following response: "
                    + testResponse);

            return testResponse;
        }
        finally
        {
            MDC.remove(TestResource.SESSION_ID_LOGGING_KEY);
        }
    }

    protected Logger getLogger()
    {
        return this.logger;
    }
}
